#include <cstdlib>
#include "RTCompConnect.h"

// examplesimpleIO³䥢ƥ١ȡǥƥ١ȹԤ碌ᥤʸƥ

//!port̾ݡֹĴ٤
#define RESOLVE_PORT_NAME

int main(int argc,char *argv[])
{
	RTCompControl *comp[2];
	std::string option="";
	if(argc == 2)option = argv[1];

	if(option == "connect" || option == "")
	{
		std::cout << "Connect components" << std::endl;

		//͡ॵФ
		RTCompConnect connector("127.0.0.1",9876);

		#ifdef RESOLVE_PORT_NAME
		//ݡȤ
		if(!connector.SetPort(0,"ConsoleIn0.rtc" ,"out"))return -1;
		if(!connector.SetPort(1,"ConsoleOut0.rtc","in") )return -1;
		#else
		//ݡȤ
		if(!connector.SetPort(0,"ConsoleIn0.rtc" , 0))return -1;
		if(!connector.SetPort(1,"ConsoleOut0.rtc", 0) )return -1;
		#endif
		//ԡ󥹥ȥ饯ȡƥ
		RTCompConnect connector2(connector);
		//³
		if(!connector2.Connect("MyConnection0"))return -1;
	}

	if(option == "activate" || option == "")
	{
		std::cout << "Activate components" << std::endl;
		comp[0]      = new RTCompControl("127.0.0.1",9876);
		comp[1]      = new RTCompControl("127.0.0.1",9876);

		//ݡͥȤΥå(RTCLinkɽƤ륳ݡͥ̾)
		comp[0]->SetRTComponent("ConsoleIn0.rtc");
		comp[1]->SetRTComponent("ConsoleOut0.rtc");

		//ƥ١
		comp[0]->Activate();
		comp[1]->Activate();
		delete comp[0];
		delete comp[1];
	}
	if(option == "deactivate")
	{	
		std::cout << "Deactivate components" << std::endl;
		comp[0]      = new RTCompControl("127.0.0.1",9876);
		comp[1]      = new RTCompControl("127.0.0.1",9876);

		//ݡͥȤΥå(RTCLinkɽƤ륳ݡͥ̾)
		comp[0]->SetRTComponent("ConsoleIn0.rtc");
		comp[1]->SetRTComponent("ConsoleOut0.rtc");

		//ǥƥ١
		comp[0]->Deactivate();
		comp[1]->Deactivate();
		
		delete comp[0];
		delete comp[1];
	}
	return 0;
}

